#ifndef __BASE_ATTRIBUT__
#define __BASE_ATTRIBUT__

using std::ostream;
using namespace blitz ;

using XMLIOSERVER::XMLIOIncompatibleTypeException;

namespace XMLIOSERVER
{
   class BaseAttribut
   {
      protected :

         BaseAttribut(void)
         { /* Ne rien faire de plus */ }

         BaseAttribut(const BaseAttribut& _ba)
         { /* Ne rien faire de plus */ }

      public :

         friend ostream& operator <<(ostream& _out,const BaseAttribut& _attr)
         { return (_attr.print(_out)) ; }

         bool hasId(void) const { return (true); }

      public : /* virtual */

         virtual string getId(void) const { return (getName()); } ;

         virtual bool      hasValue     (void)          const = 0;
         virtual string    getName      (void)          const = 0;
         virtual ostream & print        (ostream& o)    const = 0;
         virtual void      assignValue  (const BaseAttribut*) = 0;
         virtual void      setFromString(const std::string&)  = 0;

#define  SETTER_AND_GETTER(TYPE)                                                     \
         virtual void setValue(const TYPE&)           { BaseAttribut::error_set() ; }\
         virtual void setValue(const Array<TYPE,1>&)  { BaseAttribut::error_set() ; }\
         virtual void setValue(const Array<TYPE,2>&)  { BaseAttribut::error_set() ; }\
         virtual void setValue(const Array<TYPE,3>&)  { BaseAttribut::error_set() ; }\
         virtual void setValue(const Array<TYPE,4>&)  { BaseAttribut::error_set() ; }\
         virtual void getValue(TYPE&)          const  { BaseAttribut::error_get() ; }\
         virtual void getValue(Array<TYPE,1>&) const  { BaseAttribut::error_get() ; }\
         virtual void getValue(Array<TYPE,2>&) const  { BaseAttribut::error_get() ; }\
         virtual void getValue(Array<TYPE,3>&) const  { BaseAttribut::error_get() ; }\
         virtual void getValue(Array<TYPE,4>&) const  { BaseAttribut::error_get() ; }

         SETTER_AND_GETTER(int)
         SETTER_AND_GETTER(bool)
         SETTER_AND_GETTER(double)
         SETTER_AND_GETTER(char)
         SETTER_AND_GETTER(std::string)

#undef SETTER_AND_GETTER

         virtual ~BaseAttribut(void)
         { /* Ne rien faire de plus */ }

      public : /* static */

         static void error_set(void)
         { throw XMLIOIncompatibleTypeException
           ("BaseAttribut::set<type> > Setting value type is incompatible with attribut type"); }

         static void error_get(void)
         { throw XMLIOIncompatibleTypeException
           ("BaseAttribut::set<type> >Getting value type is incompatible with attribut type"); }

   }; //class BaseAttribut
} // namespace XMLIOSERVER

#endif //__BASE_ATTRIBUT__




