#ifndef __FIELD_ATTRIBUT__
#define __FIELD_ATTRIBUT__

namespace XMLIOSERVER
{
   class FieldAttribut : public virtual AttributRegistrar
   {
      public :

         DECLARE_ATTR(name         , string) ;
         DECLARE_ATTR(standard_name, string) ;
         DECLARE_ATTR(long_name    , string) ;

         DECLARE_ATTR(unit         , string) ;
         DECLARE_ATTR(operation    , FieldOperation) ;

         DECLARE_ATTR(freq_op      , Duration) ;
         DECLARE_ATTR(level        , int) ;
         DECLARE_ATTR(prec         , int) ;

         DECLARE_ATTR(enabled      , bool) ;

         DECLARE_ATTR(domain_ref   , string) ;
         DECLARE_ATTR(axis_ref     , string) ;
         DECLARE_ATTR(grid_ref     , string) ;
         DECLARE_ATTR(zoom_ref     , string) ;
         DECLARE_ATTR(field_ref    , string) ;

         FieldAttribut(void) : AttributRegistrar()
         { this->registerAllAttributes(); }

      private :

         void registerAllAttributes(void)
         {
            RegisterAttribut(&name) ;
            RegisterAttribut(&standard_name) ;
            RegisterAttribut(&long_name) ;
            RegisterAttribut(&unit) ;
            RegisterAttribut(&operation);

            RegisterAttribut(&freq_op) ;
            RegisterAttribut(&level) ;
            RegisterAttribut(&prec) ;
            RegisterAttribut(&enabled);

            RegisterAttribut(&domain_ref) ;
            RegisterAttribut(&axis_ref) ;
            RegisterAttribut(&grid_ref) ;
            RegisterAttribut(&zoom_ref) ;
            RegisterAttribut(&field_ref) ;
         }

   } ; // class FieldAttribut

}// namespace XMLIOSERVER

#endif //__FIELD_ATTRIBUT__
